Imports System.Drawing.Imaging

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Const WID As Integer = 200
        Dim path_name As String = Application.StartupPath
        If path_name.EndsWith("\bin") Then path_name = path_name.Substring(0, path_name.Length - 4)
        Dim file_name As String = path_name & "\test.wmf"

        ' Delete the file if it exists.
        If Len(Dir$(file_name)) > 0 Then Kill(file_name)

        ' Make a Graphics object so we can use its hDC as a reference.
        Dim me_gr As Graphics = Me.CreateGraphics
        Dim me_hdc As IntPtr = me_gr.GetHdc

        ' Make the Metafile, using the reference hDC.
        Dim bounds As New RectangleF(0, 0, WID, WID)
        Dim mf As New Metafile(file_name, me_hdc, _
            bounds, MetafileFrameUnit.Pixel)
        me_gr.ReleaseHdc(me_hdc)

        ' Make a Graphics object and draw.
        Dim gr As Graphics = Graphics.FromImage(mf)
        gr.PageUnit = GraphicsUnit.Pixel
        gr.Clear(Color.White)
        gr.DrawEllipse(Pens.Red, bounds)
        gr.DrawLine(Pens.Blue, 0, 0, WID, WID)
        gr.DrawLine(Pens.Blue, WID, 0, 0, WID)

        ' Close the metafile and free resources.
        gr.Dispose()
        mf.Dispose()

        ' Reload the metafile and copy it into a Bitmap.
        mf = New Metafile(file_name)
        Dim bm As New Bitmap(WID, WID)
        gr = Graphics.FromImage(bm)
        Dim dest_bounds As New RectangleF(0, 0, WID, WID)
        Dim source_bounds As New RectangleF(0, 0, WID + 1, WID + 1)
        gr.DrawImage(mf, bounds, source_bounds, GraphicsUnit.Pixel)
        picOrig.SizeMode = PictureBoxSizeMode.AutoSize
        picOrig.Image = bm
        gr.Dispose()
        mf.Dispose()

        ' Redisplay the result shrunk by 50%.
        mf = New Metafile(file_name)
        picSmall.SetBounds( _
            picOrig.Right + 10, picOrig.Top, _
            picOrig.Width \ 2, picOrig.Height \ 2)
        bm = New Bitmap( _
            picSmall.ClientSize.Width, _
            picSmall.ClientSize.Height)
        gr = Graphics.FromImage(bm)
        gr.ScaleTransform(0.5, 0.5)
        gr.DrawImage(mf, bounds, source_bounds, GraphicsUnit.Pixel)
        picSmall.Image = bm
        gr.Dispose()
        mf.Dispose()
    End Sub
End Class
